<?php
namespace Teknisa\OPL\Factories;

use Doctrine\ORM\EntityManager;

class Dfs48000SaidaDoOperadorLogisticoFactory {
    #default service
    protected $connection;
    public function __construct(EntityManager $entityManager) {
        $this->connection = $entityManager->getConnection();
    }
    
    public function getDadosFilial($cdFilial) {
       
           
            $sql = "SELECT CDEMPRESA,
                  CDSERIE,
                  CDINSCESTA,
                  NMFILIAL,
                  CDINSCMUNI
                FROM FILIAL
                WHERE CDFILIAL = :P_CDFILIAL";
                
            $params = array("P_CDFILIAL" => $cdFilial);
            
            $query = $this->connection->prepare($sql);
            $query->execute($params); 
            
            return $query->fetchAll()[0];
    }
    
    public function getCdCentCust($cdFilial) {
        
        $sql = "SELECT
                    NVL(CDTIPCUSTEST, '3') CDTIPCUSTEST'
                FROM
                    PARAMFILIAL
                WHERE
                    CDFILIAL = :P_CDFILIAL";
                    
        $params = array("P_CDFILIAL" => $cdFilial);
        
        $query = $this->connection->prepare($sql);
        $query->execute($params); 
        
        return $query->fetchAll()[0];
    }
    
    
    
    public function getParamsGeracao($cdFilial) {
        
            $sql = "SELECT F.CDSERIE,
                     F.CDEMPRESA,
                     F.CDINSCESTA,
                     PF.CDTIPCUSTEST,
                     PE.IDLANCDTMAI,
                     PE.IDLANCDTMEN,
                     PF.IDLANCDTMENFIL,
                     PF.NRDIASSAIDFIL,
                     PF.DTPROCESSA AS DTPROCESSAFILI,
                     PF.IDESTONLINE, 
                     PF.IDUTCTRLFISSAID AS IDUTCTRLFISSAIDPF,
                     PF.IDUTCTRLFISENTR AS IDUTCTRLFISENTRPF,
                     PG.IDUTCTRLFISENTR AS IDUTCTRLFISENTRPG,
                     PG.IDUTCTRLFISSAID AS IDUTCTRLFISSAIDPG,
                     PG.IDUTORIGPROD,
                     PG.IDSISDOS,
                     NVL(PG.IDBLOQLANCNFOPFIL, 'N') AS IDBLOQLANCNFOPFIL,
                     F.CDFILIAL,
                     PE.NRDIASSAID,
                     (CASE PG.IDUTILDTPROC
                WHEN 'N' THEN
                SYSDATE
                ELSE DTPROCESSA END) DTPROCESSA, PF.IDLANCDTMAIFIL, PF.NRDIASSAIDPDFIL, PE.NRDIASSAIDPD
            FROM 
                (SELECT :P_CDFILIAL AS CDFILIAL,
                     NVL(IDUTILDTPROC,
                     'N') IDUTILDTPROC,
                     IDUTCTRLFISSAID,
                     IDUTCTRLFISENTR,
                     IDBLOQLANCNFOPFIL,
                     IDUTORIGPROD,
                     IDSISDOS
                FROM PARAMGERAL PG) PG, 
                (SELECT PF.CDFILIAL,
                     NVL(PF.DTPROCESSA,
                     SYSDATE) DTPROCESSA,
                     PF.IDLANCDTMENFIL,
                     PF.NRDIASSAIDFIL,
                     PF.IDLANCDTMAIFIL,
                     PF.NRDIASSAIDPDFIL,
                     PF.IDUTCTRLFISENTR,
                     PF.IDUTCTRLFISSAID,
                     PF.IDESTONLINE,
                     NVL(PF.CDTIPCUSTEST,
                     '3') AS CDTIPCUSTEST
                FROM PARAMFILIAL PF
                WHERE PF.CDFILIAL = :P_CDFILIAL) PF, 
                (SELECT :P_CDFILIAL AS CDFILIAL,
                     PE.IDLANCDTMAI,
                     PE.IDLANCDTMEN,
                     PE.NRDIASSAID,
                     PE.NRDIASSAIDPD
                FROM PARAMESTOQUE PE) PE, FILIAL F
            WHERE PG.CDFILIAL = PF.CDFILIAL(+)
                    AND PG.CDFILIAL = PE.CDFILIAL(+)
                    AND PG.CDFILIAL = F.CDFILIAL";
    
            $params = array("P_CDFILIAL" => $cdFilial);
            $query = $this->connection->prepare($sql);
            $query->execute($params);
            return $query->fetchAll()[0];
    }
    
    public function getNotaOrigem($cdFilial, $nrLanctonf) {
        
        
            $sql = "SELECT CDFILIRECE
                    FROM NOTAFISCAL
                   WHERE CDFILIAL   = :P_CDFILIAL
                     AND NRLANCTONF = :P_NRLANCTONF";
             
            $params = array("P_CDFILIAL"   => $cdFilial,
                            "P_NRLANCTONF" => $nrLanctonf);
                            
            $query = $this->connection->prepare($sql);
            $query->execute($params); 
            
            return $query->fetchAll()[0];        
    }
    
    
    
    public function getItensOrigem($cdFilial, $nrLanctonf, $cdFiliRece) {

        $sql = "SELECT P.CDPRODUTO,
              P.CDARVPROD,
              P.NMPRODUTO,
              P.IDPRODATIVPR,
              OP.QTDEVOLUCAOOL,
              OP.CDMOTIVODEV,
              OP.VRUNITITEM,
              OP.VRTOTAITEM,
              OP.NRSEQITPROD,
              OP.VRFATOCONV,
              OP.NRSUBLOTE,
              OP.CDMARCA,
              OP.NRLOTEESTQ,
              OP.QTITEMPROD,
              OP.IDCNTRESTOQ
            FROM PRODUTO P,
              (SELECT I.CDPRODUTO,
                I.QTDEVOLUCAOOL,
                (I.QTDEVOLUCAOOL * I.VRUNITITEM) VRTOTAITEM,
                I.VRUNITITEM,
                I.NRSEQITPROD,
                I.CDMOTIVODEV,
                PROD.VRFATOCONV,
                I.NRSUBLOTE,
                I.CDMARCA,
                I.NRLOTEESTQ,
                QTITEMPROD,
                PF.IDCNTRESTOQ
              FROM ITEMPRODUTO I,
                PRODUTO PROD,
                PRODFILI PF
              WHERE I.CDFILIAL     = :P_CDFILIAL
              AND I.NRLANCTONF     = :P_NRLANCTONF
              AND PF.CDFILIAL      = :P_CDFILIRECE
              AND PF.CDPRODUTO     = PROD.CDPRODUTO
              AND I.QTDEVOLUCAOOL  > 0
              AND (I.IDDEVOLUCAOOL = 'N'
              OR I.IDDEVOLUCAOOL  IS NULL)
              AND I.CDPRODUTO      = PROD.CDPRODUTO
              ) OP
            WHERE P.CDPRODUTO = OP.CDPRODUTO
            ORDER BY NMPRODUTO";
                
        $params = array("P_CDFILIAL"   => $cdFilial,
                        "P_NRLANCTONF" => $nrLanctonf,
                        "P_CDFILIRECE" => $cdFiliRece); 
                        
        $query = $this->connection->prepare($sql);
        $query->execute($params); 
        
        return $query->fetchAll();
    }
    
    public function getQtEstoqDia($cdFilial, $cdProduto, $dtFinal) {
        $sql = "SELECT SUM(QTESTOQDIA) QTESTOQDIA
                FROM POSESTDIA P,
                  PRODUTO PROD
                WHERE (P.CDFILIAL    = :P_CDFILIAL)
                AND (PROD.CDPRODUTO  = :P_CDPRODUTO)
                AND (PROD.CDPRODESTO = P.CDPRODUTO)
                AND (P.QTESTOQDIA    > 0.00)
                AND (P.DTPOSIESTQ    =
                  (SELECT MAX(DTPOSIESTQ)
                  FROM POSESTDIA D
                  WHERE (D.CDFILIAL   = P.CDFILIAL)
                  AND (D.CDPRODUTO    = P.CDPRODUTO)
                  AND (D.CDALMOXARIFE = P.CDALMOXARIFE)
                  AND (D.CDLOCALESTOQ = P.CDLOCALESTOQ)
                  AND (D.NRLOTEESTQ   = P.NRLOTEESTQ)
                  AND (D.NRSUBLOTE    = P.NRSUBLOTE)
                  AND (D.DTPOSIESTQ  <= :P_DTFINAL)
                  ))";
                  
        $params = array("P_CDFILIAL"   => $cdFilial,
                        "P_CDPRODUTO"  => $cdProduto,
                        "P_DTFINAL"    => $dtFinal);
                        
        $query = $this->connection->prepare($sql);
        $query->execute($params); 
        
        return $query->fetchAll();
    }
    
    
    
    public function updateNotaDevol($cdFilial, $idNfDevoOl, $nrLanctonf) {
        $sql = "UPDATE NOTAFISCAL
                SET IDNFDEVOOL = :P_IDNFDEVOOL
                WHERE CDFILIAL = :P_CDFILIAL
                AND NRLANCTONF = :P_NRLANCTONF";
                
        $params = array("P_CDFILIAL"    => $cdFilial,
                        "P_IDNFDEVOOL"  => $idNfDevoOl,
                        "P_NRLANCTONF"  => $nrLanctonf);
                        
        $query = $this->connection->prepare($sql);
        return $query->execute($params); 
    }
    
    public function insereItemNota($cdFilial, $nrLanctonf, $nrSeqItProd, $cdFilialIt, $nrLanctonfit, $nrOrg) {
        $sql = "INSERT
                INTO ITEMNOTAFISC
                  (
                    CDFILIAL,
                    NRLANCTONF,
                    NRSEQUITNOTA,
                    CDFILIALIT,
                    NRLANCTONFIT,
                    NRORG
                  )
                  VALUES
                  (
                    :P_CDFILIAL,
                    :P_NRLANCTONF,
                    :P_NRSEQITPROD,
                    :P_CDFILIALIT,
                    :P_NRLANCTONFIT,
                    :P_NRORG
                  )";
                  
        $params = array("P_CDFILIAL"        => $cdFilial,
                        "P_NRLANCTONF"      => $nrLanctonf,
                        "P_NRSEQITPROD"     => $nrSeqItProd,
                        "P_CDFILIALIT"      => $cdFilialIt,
                        "P_NRLANCTONFIT"    => $nrLanctonfit,
                        "P_NRORG"           => $nrOrg);
                            
        $query = $this->connection->prepare($sql);
        return $query->execute($params);           
    }
    
    
    
    public function alteraProdutoOrigDev($cdFilial, $nrLanctonf, $nrSeqItProd) {
        $sql = "UPDATE ITEMPRODUTO
                SET IDDEVOLUCAOOL = 'S'
                WHERE CDFILIAL    = :P_CDFILIAL
                AND NRLANCTONF    = :P_NRLANCTONF
                AND NRSEQITPROD   = :P_NRSEQITPROD";
                
        
        $params = array("P_CDFILIAL"        => $cdFilial,
                        "P_NRLANCTONF"      => $nrLanctonf,
                        "P_NRSEQITPROD"     => $nrSeqItProd);
                            
        $query = $this->connection->prepare($sql);
        return $query->execute($params);               
    }
    
    public function alteraProdutoDevolucao($cdFilial, $nrLanctonf, $cdProduto, $cdMotivoDev) {
        $sql = "UPDATE ITEMPRODUTO
                SET CDMOTIVODEV = :P_CDMOTIVODEV
                WHERE CDFILIAL  = :P_CDFILIAL
                AND NRLANCTONF  = :P_NRLANCTONF
                AND CDPRODUTO   = :P_CDPRODUTO";
        
        $params = array("P_CDMOTIVODEV"     => $cdMotivoDev,
                        "P_CDFILIAL"        => $cdFilial,
                        "P_NRLANCTONF"      => $nrLanctonf,
                        "P_CDPRODUTO"       => $cdProduto);
                            
        $query = $this->connection->prepare($sql);
        return $query->execute($params); 
    }
    
    
    
    public function getMotivoDev($cdMotivoDev) {
        $sql = "SELECT CDMOTIVODEV,
                  NMMOTIVODEV,
                  IDSENHAAUTDEV,
                  IDGERAOCORATE,
                  IDGERAPEDOL,
                  DSHORALIMPRI,
                  DSHORALIMSEG,
                  CDLOTEENVPEDPRI,
                  CDLOTEENVPEDSEG,
                  TO_CHAR(SYSDATE, 'HH24MI')HORABANCO,
                  SYSDATE AS DATADIA
                FROM MOTIVODEV
                WHERE CDMOTIVODEV = :P_CDMOTIVODEV";
        
        $params = array("P_CDMOTIVODEV" => $cdMotivoDev);
                            
        $query = $this->connection->prepare($sql);
        $query->execute($params); 
        
        return $query->fetchAll()[0];
    }
    
    public function getCdFornOpLog($cdFilial) {
        $sql = "SELECT CDFORNOPELOG FROM FILIAL WHERE CDFILIAL = :P_CDFILIAL";
        
        $params = array("P_CDFILIAL" => $cdFilial);
                            
        $query = $this->connection->prepare($sql);
        $query->execute($params); 
        
        return $query->fetchAll()[0];   
    }
    
    
    
    public function getContopectbl($cdEmpresa) {
        $sql = "SELECT DTINIINTCONTDFE,
                  DTFININTCONTDFE,
                  DTINIINTCONTDFS,
                  DTFININTCONTDFS
                FROM CONTOPECTBL
                WHERE (CDEMPRESA = :P_CDEMPRESA)";
                
        $params = array("P_CDEMPRESA" => $cdEmpresa);
        $query = $this->connection->prepare($sql);
        $query->execute($params);
        return $query->fetchAll();
    }
    
    public function getProdFili($cdFilial, $cdProduto) {
        $sql = "SELECT PRODFILI.IDPRODATIV, FILIAL.CDFILIAL, FILIAL.NMFILIAL
      
            FROM FILIAL INNER JOIN PRODFILI ON FILIAL.CDFILIAL    = PRODFILI.CDFILIAL 
        WHERE FILIAL.CDFILIAL      = :P_CDFILIAL
            AND PRODFILI.CDPRODUTO = :P_CDPRODUTO";
            
        $params = array("P_CDFILIAL"  => $cdFilial,
                        "P_CDPRODUTO" => $cdProduto);
                        
        $query = $this->connection->prepare($sql);
        $query->execute($params);
        return $query->fetchAll();
    }
    
    
    
    public function insereLote($cdFilial, $nrLoteestq, $nrSubLote, $cdProduto) {
        $sql = "INSERT
                INTO LOTE
                  (
                    CDFILIAL,
                    NRLOTEESTQ,
                    NRSUBLOTE,
                    CDPRODUTO,
                    IDSTATLOTE,
                    DTENTRLOTE,
                    NRORG
                  )
                  (SELECT :P_CDFILIAL CDFILIAL,
                      :P_NRLOTEESTQ NRLOTEESTQ,
                      :P_NRSUBLOTE NRSUBLOTE,
                      :P_CDPRODUTO CDPRODUTO,
                      'L' IDSTATLOTE,
                      SYSDATE DTENTRLOTE,
                      NRORG
                    FROM PARAMGERAL
                    MINUS
                    SELECT CDFILIAL,
                      NRLOTEESTQ,
                      NRSUBLOTE,
                      :P_CDPRODUTO CDPRODUTO,
                      'L',
                      SYSDATE,
                      NRORG
                    FROM LOTE
                    WHERE :P_CDFILIAL = CDFILIAL
                    AND :P_NRLOTEESTQ = NRLOTEESTQ
                    AND :P_NRSUBLOTE  = NRSUBLOTE
                    AND :P_CDPRODUTO  = CDPRODUTO
                  )";
                  
        $params = array("P_CDFILIAL" => $cdFilial, 
                "P_NRLOTEESTQ" => $nrLoteestq, 
                "P_NRSUBLOTE" => $nrSubLote, 
                "P_CDPRODUTO" => $cdProduto);
                        
        $query = $this->connection->prepare($sql);
        return $query->execute($params);
    }
    
    public function insereMovOcorr($cdfililancmo, $nrocorrmov, $cdfilial, $cdforneced, $dtocorrmov, $nmpessidetoc, $cdoperador, $cdproduto, $nrloteestq, $nrsublote, $nmpessautooc, $cdfilialnf, $nrlanctonf, $cdmarca, $dtentrmovocorr, $idsitumovocorr, $nrorg) {
        $sql = "INSERT
                INTO MOVOCORR
                  (
                    CDFILILANCMO,
                    NROCORRMOV,
                    CDFILIAL,
                    CDFORNECED,
                    DTOCORRMOV,
                    NMPESSIDETOC,
                    CDOPERADOR,
                    CDPRODUTO,
                    NRLOTEESTQ,
                    NRSUBLOTE,
                    NMPESSAUTOOC,
                    CDFILIALNF,
                    NRLANCTONF,
                    CDMARCA,
                    DTENTRMOVOCORR,
                    IDSITUMOVOCORR,
                    NRORG
                  )
                  VALUES
                  (
                    :CDFILILANCMO,
                    :NROCORRMOV,
                    :CDFILIAL,
                    :CDFORNECED,
                    :DTOCORRMOV,
                    :NMPESSIDETOC,
                    :CDOPERADOR,
                    :CDPRODUTO,
                    :NRLOTEESTQ,
                    :NRSUBLOTE,
                    :NMPESSAUTOOC,
                    :CDFILIALNF,
                    :NRLANCTONF,
                    :CDMARCA,
                    :DTENTRMOVOCORR,
                    :IDSITUMOVOCORR, 
                    :NRORG
                  )";
                  
        $params = array("CDFILILANCMO" => $cdfililancmo, 
                        "NROCORRMOV" => $nrocorrmov, 
                        "CDFILIAL" => $cdfilial, 
                        "CDFORNECED" => $cdforneced, 
                        "DTOCORRMOV" => $dtocorrmov, 
                        "NMPESSIDETOC" => $nmpessidetoc, 
                        "CDOPERADOR" => $cdoperador, 
                        "CDPRODUTO" => $cdproduto, 
                        "NRLOTEESTQ" => $nrloteestq, 
                        "NRSUBLOTE" => $nrsublote, 
                        "NMPESSAUTOOC" => $nmpessautooc, 
                        "CDFILIALNF" => $cdfilialnf, 
                        "NRLANCTONF" => $nrlanctonf, 
                        "CDMARCA" => $cdmarca, 
                        "DTENTRMOVOCORR" => $dtentrmovocorr, 
                        "IDSITUMOVOCORR" => $idsitumovocorr, 
                        "NRORG" => $nrorg);
                        
        $query = $this->connection->prepare($sql);
        return $query->execute($params);
    }
    
    public function getNmOperador($cdOperador) {
        $sql = "SELECT NMOPERADOR FROM OPERADOR WHERE CDOPERADOR = :P_CDOPERADOR";
        
        $params = array("P_CDOPERADOR"  => $cdOperador);
                        
        $query = $this->connection->prepare($sql);
        $query->execute($params);
        return $query->fetchAll()[0]["NMOPERADOR"];
    }
    
    public function insereDsMovOcorr($cdfililancmo, $nrocorrmov, $dsmovocorr, $nrOrg) {
        $sql = "INSERT
                INTO DESCMOVOCORR
                  (
                    CDFILILANCMO,
                    NROCORRMOV,
                    DSMOVOCORR,
                    NRORG
                  )
                  VALUES
                  (
                    :CDFILILANCMO,
                    :NROCORRMOV,
                    :DSMOVOCORR,
                    :NRORG
                  )";
                  
        $params = array("CDFILILANCMO"  => $cdfililancmo,
                        "NROCORRMOV"    => $nrocorrmov,
                        "DSMOVOCORR"    => $dsmovocorr,
                        "NRORG"         => $nrOrg);
                        
        $query = $this->connection->prepare($sql);
        return $query->execute($params);
    }
    
    
    
    public function inserePedExol($cdfildest, $cdfillanc, $nrpedexol, $dtpedexol, $idemitexol, $cdempresa, $cdfiliopelog, $idtipoexol, $idpedexolextr, $dsdocdevool, $nrorg) {
        $sql = "INSERT
                INTO PEDIDOEXOL
                  (
                    CDFILDEST,
                    CDFILLANC,
                    NRPEDEXOL,
                    DTPEDEXOL,
                    IDEMITEXOL,
                    CDEMPRESA,
                    CDFILIOPELOG,
                    IDTIPOEXOL,
                    IDPEDEXOLEXTR,
                    DSDOCDEVOOL,
                    NRORG
                  )
                  VALUES
                  (
                    :CDFILDEST,
                    :CDFILLANC,
                    :NRPEDEXOL,
                    :DTPEDEXOL,
                    :IDEMITEXOL,
                    :CDEMPRESA,
                    :CDFILIOPELOG,
                    :IDTIPOEXOL,
                    :IDPEDEXOLEXTR,
                    :DSDOCDEVOOL,
                    :NRORG
                  )";
                  
        $params = array("CDFILDEST" => $cdfildest, 
                        "CDFILLANC" => $cdfillanc, 
                        "NRPEDEXOL" => $nrpedexol, 
                        "DTPEDEXOL" => $dtpedexol, 
                        "IDEMITEXOL" => $idemitexol, 
                        "CDEMPRESA" => $cdempresa, 
                        "CDFILIOPELOG" => $cdfiliopelog, 
                        "IDTIPOEXOL" => $idtipoexol, 
                        "IDPEDEXOLEXTR" => $idpedexolextr, 
                        "DSDOCDEVOOL" => $dsdocdevool, 
                        "NRORG" => $nrorg);
                        
        $query = $this->connection->prepare($sql);
        return $query->execute($params);
    }
    
    public function getRelacPexOl($cdFilial, $nrLanctonf) {
        $sql = "SELECT N.CDFILIAL,
              N.NRLANCTONF,
              N.CDFILDEST,
              N.CDFILLANC,
              P.CDEMPRESA,
              P.CDFILIOPELOG,
              P.IDTIPOEXOL,
              P.IDPEDEXOLEXTR
            FROM NFRELACPEXOL N,
              PEDIDOEXOL P
            WHERE N.CDFILIAL = :P_CDFILIAL
            AND N.NRLANCTONF = :P_NRLANCTONF
            AND P.CDFILLANC  = N.CDFILLANC
            AND P.CDFILDEST  = N.CDFILDEST
            AND P.NRPEDEXOL  = N.NRPEDEXOL";
            
        $params = array("P_CDFILIAL"    => $cdFilial,
                        "P_NRLANCTONF"  => $nrLanctonf);
                        
        $query = $this->connection->prepare($sql);
        $query->execute($params);
        return $query->fetchAll();
    }
    
    
    
    public function getParamSupri($cdFilDest) {
        $sql = "SELECT NVL(PARASUPRI.IDUTILCONSSOLIOL, 'N') IDUTILCONSSOLIOL
            FROM FILIAL,
              PARASUPRI
            WHERE FILIAL.CDFILIAL                         = :P_CDFILDEST
            AND NVL(FILIAL.CDFILCENTCMP, FILIAL.CDFILIAL) = PARASUPRI.CDFILIAL";
            
        $params = array("P_CDFILDEST" => $cdFilDest);
                        
        $query = $this->connection->prepare($sql);
        $query->execute($params);
        return $query->fetchAll();
    }
    
    public function insereItemPedExOl($cdfildest, $cdfillanc, $nrpedexol, $cdproduto, $qtprogenpeol, $dtprogenpeol, $cdmarca, $cdlotenvitol,  $nrorg) {
        $sql = "INSERT
                INTO ITEMPEDEXOL
                  (
                    CDFILDEST,
                    CDFILLANC,
                    NRPEDEXOL,
                    CDPRODUTO,
                    QTPROGENPEOL,
                    DTPROGENPEOL,
                    CDMARCA,
                    CDLOTENVITOL,
                    DTPROGEMBARQ,
                    NRORG
                  )
                  VALUES
                  (
                    :CDFILDEST,
                    :CDFILLANC,
                    :NRPEDEXOL,
                    :CDPRODUTO,
                    :QTPROGENPEOL,
                    :DTPROGENPEOL,
                    :CDMARCA,
                    :CDLOTENVITOL,
                    :DTPROGEMBARQ, 
                    :NRORG
                  )";
                  
        $params = array("CDFILDEST" => $cdfildest,
                        "CDFILLANC" => $cdfillanc,
                        "NRPEDEXOL" => $nrpedexol,
                        "CDPRODUTO" => $cdproduto,
                        "QTPROGENPEOL" => $qtprogenpeol,
                        "DTPROGENPEOL" => $dtprogenpeol,
                        "CDMARCA" => $cdmarca,
                        "CDLOTENVITOL" => $cdlotenvitol,
                        "DTPROGEMBARQ" => $dtprogenpeol, 
                        "NRORG" => $nrorg);
                        
        $query = $this->connection->prepare($sql);
        return $query->execute($params);
    }
    
    
    
    public function updateItemAutAf($qtefetentraf, $idbaixitmaf, $cdfildest, $cdfillanc, $nrautoforn, $cdmarca, $cdproduto, $dtprogentaf) {
        $sql = "UPDATE ITEMAUTF
            SET QTEFETENTRAF = :P_QTEFETENTRAF,
              IDBAIXITMAF    = :P_IDBAIXITMAF,
              IDBAIXITAFS    = :P_IDBAIXITMAF
            WHERE CDFILDEST  = :P_CDFILDEST
            AND CDFILLANC    = :P_CDFILLANC
            AND NRAUTOFORN   = :P_NRAUTOFORN
            AND CDMARCA      = :P_CDMARCA
            AND CDPRODUTO    = :P_CDPRODUTO
            AND DTPROGENTAF  = :P_DTPROGENTAF";
            
        $params = array("P_QTEFETENTRAF" => $qtefetentraf,
                    "P_IDBAIXITMAF" => $idbaixitmaf,
                    "P_CDFILDEST" => $cdfildest,
                    "P_CDFILLANC" => $cdfillanc,
                    "P_NRAUTOFORN" => $nrautoforn,
                    "P_CDMARCA" => $cdmarca,
                    "P_CDPRODUTO" => $cdproduto,
                    "P_DTPROGENTAF" => $dtprogentaf);
                    
        $query = $this->connection->prepare($sql);
        return $query->execute($params);
    }
    
    public function getItemAutAf($cdFilDest, $nrLanctonf, $cdMarca, $cdProduto) {
        $sql = "SELECT ITEMAUTF.CDFILDEST,
              ITEMAUTF.CDFILLANC,
              ITEMAUTF.NRAUTOFORN,
              ITEMAUTF.CDMARCA,
              ITEMAUTF.CDPRODUTO,
              ITEMAUTF.DTPROGENTAF,
              ITEMAUTF.QTPROGENTAF,
              ITEMAUTF.QTEFETENTRAF,
              NFRELACAF.NRLANCTONF
            FROM ITEMAUTF,
              NFRELACAF
            WHERE NFRELACAF.CDFILIAL  = :P_CDFILDEST
            AND NFRELACAF.NRLANCTONF  = :P_NRLANCTONF
            AND NFRELACAF.CDFILDEST   = ITEMAUTF.CDFILDEST
            AND NFRELACAF.CDFILLANC   = ITEMAUTF.CDFILLANC
            AND NFRELACAF.NRAUTOFORN  = ITEMAUTF.NRAUTOFORN
            AND NFRELACAF.CDMARCA     = ITEMAUTF.CDMARCA
            AND NFRELACAF.CDPRODUTO   = ITEMAUTF.CDPRODUTO
            AND NFRELACAF.DTPROGENTAF = ITEMAUTF.DTPROGENTAF
            AND NFRELACAF.CDMARCA     = :P_CDMARCA
            AND NFRELACAF.CDPRODUTO   = :P_CDPRODUTO";
            
        $params = array("P_CDFILDEST"  => $cdFilDest,
                        "P_NRLANCTONF" => $nrLanctonf,
                        "P_CDMARCA"    => $cdMarca,
                        "P_CDPRODUTO"  => $cdProduto);
                        
        $query = $this->connection->prepare($sql);
        $query->execute($params);
        return $query->fetchAll();
    }
    
    
    
    
    public function updateAutoForne($idBaixaAf, $cdFilDest, $cdFilLanc, $nrAutoForn) {
        $sql = "UPDATE AUTOFORNE
                 SET IDBAIXAAF    = :P_IDBAIXAAF
               WHERE CDFILDEST    = :P_CDFILDEST
                 AND CDFILLANC    = :P_CDFILLANC
                 AND NRAUTOFORN   = :P_NRAUTOFORN";
                 
        $params = array("P_IDBAIXAAF"  => $idBaixaAf,
                        "P_CDFILDEST"  => $cdFilDest,
                        "P_CDFILLANC"  => $cdFilLanc,
                        "P_NRAUTOFORN" => $nrAutoForn);
                        
        $query = $this->connection->prepare($sql);
        return $query->execute($params);
    }
    
    public function getItemAutAf2($cdFilDest, $cdFilLanc, $nrAutoForn) {
        $sql = "SELECT NRAUTOFORN
                FROM ITEMAUTF
                WHERE CDFILDEST          = :P_CDFILDEST
                AND CDFILLANC            = :P_CDFILLANC
                AND NRAUTOFORN           = :P_NRAUTOFORN
                AND NVL(IDBAIXITMAF, 0) IN (1, 2)";
                
        $params = array("P_CDFILDEST"  => $cdFilDest,
                        "P_CDFILLANC"  => $cdFilLanc,
                        "P_NRAUTOFORN" => $nrAutoForn);
        
        $query = $this->connection->prepare($sql);
        $query->execute($params);
        return $query->fetchAll();
    }
    
    
    
    public function getInfoTipoOperac($cdTipoOper, $idEntrSaid) {
        $sql = "SELECT IDATUESTTPOP
            FROM TIPOOPERAC
            WHERE IDENTRSAIDOP = 'S'
              AND CDTIPOOPER   = :P_CDTIPOOPER
              AND IDENTRSAIDOP = :P_IDENTRSAIDOP";
        
        $params = array("P_CDTIPOOPER"     => $cdTipoOper,
                         "P_IDENTRSAIDOP"   => $idEntrSaid);
        
        $query = $this->connection->prepare($sql);
        $query->execute($params);
        return $query->fetchAll();    
    }
    
    public function insereDadosAdic($cdFilial, $nrLanctonf, $nrDadosADic, $cdMensagem, $dsDadosAdic, $nrOrg) {
        $sql = "INSERT
                INTO DADOSADIC
                  (
                    CDFILIAL,
                    NRLANCTONF,
                    NRDADOADIC,
                    CDMENSAGEM,
                    DSDADOADIC,
                    NRORG
                  )
                  VALUES
                  (
                    :CDFILIAL,
                    :NRLANCTONF,
                    :NRDADOADIC,
                    :CDMENSAGEM,
                    :DSDADOADIC,
                    :NRORG
                  )";
                  
        $params = array("CDFILIAL"      => $cdFilial,
                        "NRLANCTONF"    => $nrLanctonf,
                        "NRDADOADIC"    => $nrDadosADic,
                        "CDMENSAGEM"    => $cdMensagem, 
                        "DSDADOADIC"    => $dsDadosAdic,
                        "NRORG"         => $nrOrg);
        
        $query = $this->connection->prepare($sql);
        return $query->execute($params);
    }
    
    
    
    public function getItemProdutoNota($cdFilial, $nrLanctonf) {
        $sql = "SELECT I.CDFILIAL,
                  I.NRLANCTONF,
                  I.NRSEQITPROD,
                  P.CDARVPROD,
                  P.NMPRODUTO,
                  I.QTITEMPROD,
                  I.VRUNITITEM,
                  I.VRTOTAITEM,
                  I.IDDEVOLUCAOOL IDDEVOLVIDO,
                  (I.QTITEMPROD - NVL(I.QTDEVOLUCAOOL, 0)) QTENTREGUE,
                  NVL(I.QTDEVOLUCAOOL, 0) QTDEVOLUCAOOL,
                  P.SGUNIDADE,
                  I.CDFISOPEITEM,
                  I.CDMOTIVODEV,
                  M.NMMOTIVODEV
                FROM ITEMPRODUTO I,
                  PRODUTO P,
                  MOTIVODEV M
                WHERE I.CDFILIAL  = :P_CDFILIAL
                AND I.NRLANCTONF  = :P_NRLANCTONF
                AND I.CDPRODUTO   = P.CDPRODUTO
                AND I.CDMOTIVODEV = M.CDMOTIVODEV(+)
                ORDER BY P.CDARVPROD";
                
        $params = array("P_CDFILIAL"     => $cdFilial,
                        "P_NRLANCTONF"   => $nrLanctonf);
        
        $query = $this->connection->prepare($sql);
        $query->execute($params);
        return $query->fetchAll();  
    }
    
    public function getCdModDocFisc($cdFilial, $nrLanctonf) {
        $sql = "SELECT CDMODDOCFISC
                FROM NOTAFISCAL
                WHERE CDFILIAL = :P_CDFILIAL
                AND NRLANCTONF = :P_NRLANCTONF";
                
        $params = array("P_CDFILIAL"     => $cdFilial,
                        "P_NRLANCTONF"   => $nrLanctonf);
        
        $query = $this->connection->prepare($sql);
        $query->execute($params);
        return $query->fetchAll();            
    }
    
    
    
    public function getDadosNf($cdFilial, $nrLanctonf) {
        $sql = "SELECT IDENTRSAIDOP,
                  CDTIPOOPER
                FROM NOTAFISCAL
                WHERE CDFILIAL = :P_CDFILIAL
                AND NRLANCTONF = :P_NRLANCTONF";
                
        $params = array("P_CDFILIAL" => $cdFilial,
                        "P_NRLANCTONF" => $nrLanctonf);
        
        $query = $this->connection->prepare($sql);
        $query->execute($params); 
        
        return $query->fetchAll()[0];  
    }
    
    public function getImpostoNota($cdFilial, $nrLanctonf, $cdImposto) {
        $sql = "SELECT MAX(CDFILIAL) AS CDFILIAL
                FROM IMPOSTONF
                WHERE CDFILIAL   = :P_CDFILIAL
                AND NRLANCTONF = :P_NRLANCTONF
                AND CDIMPOSTO  = :P_CDIMPOSTO";
                
        $params = array("P_CDFILIAL"     => $cdFilial,
                        "P_NRLANCTONF"   => $nrLanctonf,
                        "P_CDIMPOSTO"    => $cdImposto);
                
        $query = $this->connection->prepare($sql);
        $query->execute($params);
        return $query->fetchAll();
    }
    
     
    
     public function getImpostoProdutos($cdFilial, $nrLanctonf, $cdImposto) {
        
        $sql = "SELECT A.CDPRODUTO,
                  A.CDFILIAL,
                  P.CDARVPROD,
                  P.NMPRODUTO
                FROM ITEMPRODUTO A,
                  PRODUTO P
                WHERE A.CDFILIAL = :P_CDFILIAL
                AND A.NRLANCTONF = :P_NRLANCTONF
                AND A.CDPRODUTO  = P.CDPRODUTO
                AND NOT EXISTS
                  (SELECT CDFILIAL
                  FROM ITEMPROIMPOS I
                  WHERE I.CDFILIAL  = A.CDFILIAL
                  AND I.NRLANCTONF  = A.NRLANCTONF
                  AND I.NRSEQITPROD = A.NRSEQITPROD
                  AND I.CDIMPOSTO   = :P_CDIMPOSTO
                  )";
        
        $params = array("P_CDFILIAL" => $cdFilial,
                        "P_NRLANCTONF" => $nrLanctonf,
                        "P_CDIMPOSTO" => $cdImposto);
        
        $query = $this->connection->prepare($sql);
        $query->execute($params); 
        
        return $query->fetchAll();
    }
    
    public function getImpostoObrigatorio($idEntrSaid, $cdTipoOper) {
        $sql = "SELECT I.CDIMPOSTO,
                  IM.IDPRODNOTA,
                  IM.SGIMPOSTO
                FROM IMPOBRIGTPOPER I,
                  IMPOSTO IM
                WHERE I.IDENTRSAIDOP = :P_IDENTRSAIDOP
                AND I.CDTIPOOPER     = :P_CDTIPOOPER
                AND IM.CDIMPOSTO     = I.CDIMPOSTO";
                
        $params = array("P_IDENTRSAIDOP" => $idEntrSaid,
                        "P_CDTIPOOPER" => $cdTipoOper);
        
        $query = $this->connection->prepare($sql);
        $query->execute($params); 
        
        return $query->fetchAll();  
    }
    
    
    
    public function deleteRateioNf($cdFilial, $nrLanctonf) {
        $sql = "DELETE RATEIONF WHERE CDFILIAL   = :P_CDFILIAL 
                AND NRLANCTONF = :P_NRLANCTONF";
                
        $params = array("P_CDFILIAL"      => $cdFilial,
                        "P_NRLANCTONF"    => $nrLanctonf); 
                 
        $query = $this->connection->prepare($sql);
        $query->execute($params);    
    }
    
    public function getTipoContaReceber($cdFilial, $nrLanctonf) {
        $sql = "SELECT TR.CDTPCTRECEB,
                  TR.CDCLASSFINA
                FROM
                  (SELECT MAX(CDARVPROD) AS CDARVPROD
                  FROM ITEMPRODUTO I,
                    PRODUTO P
                  WHERE CDFILIAL  = :P_CDFILIAL
                  AND NRLANCTONF  = :P_NRLANCTONF
                  AND I.CDPRODUTO = P.CDPRODUTO
                  GROUP BY VRTOTAITEM
                  HAVING VRTOTAITEM =
                    (SELECT MAX(VRTOTAITEM)
                    FROM ITEMPRODUTO
                    WHERE CDFILIAL = :P_CDFILIAL
                    AND NRLANCTONF = :P_NRLANCTONF
                    )
                  ) IT,
                  PRODUTO PR ,
                  TIPOCTRECEBER TR
                WHERE TR.CDTPCTRECEB = PR.CDTPCTRECEB
                AND PR.CDARVPROD     =
                  (SELECT MAX(P.CDARVPROD)
                  FROM TIPOCTRECEPROD C,
                    PRODUTO P
                  WHERE C.CDPRODUTO                            = P.CDPRODUTO
                  AND (INSTR(IT.CDARVPROD, RTRIM(P.CDARVPROD)) = 1)
                  )";
                  
        $params = array("P_CDFILIAL" => $cdFilial,
                        "P_NRLANCTONF" => $nrLanctonf);
        
        $query = $this->connection->prepare($sql);
        $query->execute($params); 
        
        return $query->fetchAll();
    }
    
    
    
    
    public function getConsContaRateio($idEntrSaid, $cdTipoOper) {
        $sql = "SELECT NVL(IDCONSCTBRAT, 'N') AS IDCONSCTBRAT
                FROM TIPOOPERAC
                WHERE IDENTRSAIDOP = :P_IDENTRSAIDOP
                AND CDTIPOOPER     = :P_CDTIPOOPER";
                
        $params = array("P_IDENTRSAIDOP"  => $idEntrSaid,
                        "P_CDTIPOOPER"    => $cdTipoOper); 
        
        $query = $this->connection->prepare($sql);
        $query->execute($params);    
        
        return $query->fetchAll()[0];  
    }
    
    public function getNotaFiscalRateio($cdFilial, $nrLanctonf) {
        $sql = "SELECT CDFILIRECE,
                  CDTIPOOPER,
                  CDFILIEMIT,
                  DTEMISSAO,
                  DTENTRSAID,
                  NVL(IDORIGDESTNF,'F')      AS IDORIGDESTNF,
                  NVL(IDNFGERADAVIAXML, 'N') AS IDNFGERADAVIAXML
                FROM NOTAFISCAL
                WHERE CDFILIAL = :P_CDFILIAL
                AND NRLANCTONF = :P_NRLANCTONF";
        
        $params = array("P_CDFILIAL"      => $cdFilial,
                        "P_NRLANCTONF"    => $nrLanctonf); 
                 
        $query = $this->connection->prepare($sql);
        $query->execute($params);    
        
        return $query->fetchAll()[0];  
    }
    
    
    
    public function getRatTpCtpr($cdTpCtReceb) {
        $sql = "SELECT CDFILIAL,
                  CDCENTCUST,
                  VRPERATTPCTR
                FROM RATTPCTR
                WHERE CDTPCTRECEB = :P_CDTPCTRECEB";
                
        $params = array("P_CDTPCTRECEB"    => $cdTpCtReceb); 
        
        $query = $this->connection->prepare($sql);
        $query->execute($params);    
        
        return $query->fetchAll();  
    }
    
    public function getItemProdutoRateio($cdFilial, $nrLanctonf) {
        $sql = "SELECT CDFILIAL,
                  NRLANCTONF,
                  NRSEQITPROD,
                  VRCONTITEM,
                  DSPRODEMIS
                FROM ITEMPRODUTO
                WHERE CDFILIAL = :P_CDFILIAL
                AND NRLANCTONF = :P_NRLANCTONF";
                
        $params = array("P_CDFILIAL"    => $cdFilial,
                        "P_NRLANCTONF"  => $nrLanctonf); 
        
        $query = $this->connection->prepare($sql);
        $query->execute($params);    
        
        return $query->fetchAll();  
    }
    
    
    
    public function updateRateioNf($vrRateNf, $vrPerRat, $cdFilial, $nrLanctonf, $nrSeqItProd, $cdFilcCust, $cdCentcusnf) {
        $sql = "UPDATE RATEIONF
                SET VRRATENF    = VRRATENF + :P_VRRATENF,
                  VRPERRAT      = VRPERRAT + :P_VRPERRAT
                WHERE CDFILIAL  = :P_CDFILIAL
                AND NRLANCTONF  = :P_NRLANCTONF
                AND NRSEQITPROD = :P_NRSEQITPROD
                AND CDFILICCUST = :P_CDFILICCUST
                AND CDCENTCUSNF = :P_CDCENTCUSNF";
                
        $params = array("P_VRRATENF"    => $vrRateNf,
                        "P_VRPERRAT"    => $vrPerRat,
                        "P_CDFILIAL"    => $cdFilial,
                        "P_NRLANCTONF"  => $nrLanctonf,
                        "P_NRSEQITPROD" => $nrSeqItProd,
                        "P_CDFILICCUST" => $cdFilcCust,
                        "P_CDCENTCUSNF" => $cdCentcusnf); 
        
        $query = $this->connection->prepare($sql);
        return $query->execute($params);        
    }
    
    public function getRateioNf($cdFilial, $nrLanctonf, $nrSeqItProd, $cdFilcCust, $cdCentcusnf) {
        $sql = "SELECT CDFILIAL
                FROM RATEIONF
                WHERE CDFILIAL  = :P_CDFILIAL
                AND NRLANCTONF  = :P_NRLANCTONF
                AND NRSEQITPROD = :P_NRSEQITPROD
                AND CDFILICCUST = :P_CDFILICCUST
                AND CDCENTCUSNF = :P_CDCENTCUSNF";
                
        $params = array("P_CDFILIAL"    => $cdFilial,
                        "P_NRLANCTONF"  => $nrLanctonf,
                        "P_NRSEQITPROD" => $nrSeqItProd,
                        "P_CDFILICCUST" => $cdFilcCust,
                        "P_CDCENTCUSNF" => $cdCentcusnf); 
        
        $query = $this->connection->prepare($sql);
        $query->execute($params);    
        
        return $query->fetchAll();  
    }
    
    
    
    public function insereRateioNf2($cdFilial, $nrLanctonf) {
        $sql = "INSERT
                INTO RATEIONF
                  (
                    CDFILIAL,
                    NRLANCTONF,
                    NRSEQITPROD,
                    CDFILICCUST,
                    VRRATENF,
                    CDCENTCUSNF,
                    VRPERRAT,
                    NRORG
                  )
                  (SELECT I.CDFILIAL,
                      I.NRLANCTONF,
                      I.NRSEQITPROD,
                      N.CDFILIEMIT,
                      I.VRCONTITEM,
                      NVL(NVL(NVL(PF.CDCCUSTSAIDF,P.CDCCUSTSAID),F.CDCENTCUST) ,E.CDCENTCUST) CDCENTCUST,
                      100 AS VRPERRAT,
                      :NRORG
                    FROM NOTAFISCAL N,
                      ITEMPRODUTO I,
                      PRODFILI PF,
                      PRODUTO P,
                      EMPRESA E,
                      FILIAL F
                    WHERE N.CDFILIAL                                                             = :P_CDFILIAL
                    AND N.NRLANCTONF                                                             = :P_NRLANCTONF
                    AND I.CDFILIAL                                                               = :P_CDFILIAL
                    AND I.NRLANCTONF                                                             = :P_NRLANCTONF
                    AND I.CDPRODUTO                                                              = PF.CDPRODUTO
                    AND PF.CDFILIAL                                                              = N.CDFILIEMIT
                    AND I.CDPRODUTO                                                              = P.CDPRODUTO
                    AND N.CDEMPRESA                                                              = E.CDEMPRESA
                    AND N.CDFILIEMIT                                                             = F.CDFILIAL
                    AND NVL(NVL(NVL(PF.CDCCUSTSAIDF,P.CDCCUSTSAID),F.CDCENTCUST), E.CDCENTCUST) IS NOT NULL
                  )";
                  
        $params = array("P_CDFILIAL"      => $cdFilial,
                        "P_NRLANCTONF"    => $nrLanctonf,
                        "P_NRORG"         => $nrOrg); 
        
        $query = $this->connection->prepare($sql);
        return $query->execute($params);    
    }
    
    public function insereRateioNf($vrRateNf, $vrPerRat, $cdFilial, $nrLanctonf, $nrSeqItProd, $cdFilcCust, $cdCentcusnf, $nrOrg) {
        $sql = "INTO RATEIONF
                  (
                    CDFILIAL,
                    NRLANCTONF,
                    NRSEQITPROD,
                    CDFILICCUST,
                    VRRATENF,
                    CDCENTCUSNF,
                    VRPERRAT,
                    NRORG
                  )
                  VALUES
                  (
                    :P_CDFILIAL,
                    :P_NRLANCTONF,
                    :P_NRSEQITPROD,
                    :P_CDFILICCUST,
                    :P_VRRATENF,
                    :P_CDCENTCUSNF,
                    :P_VRPERRAT
                    :P_NRORG
                  )";
                  
        $params = array("P_CDFILIAL"    => $cdFilial,
                        "P_NRLANCTONF"  => $nrLanctonf,
                        "P_NRSEQITPROD" => $nrSeqItProd,
                        "P_CDFILICCUST" => $cdFilcCust,
                        "P_CDCENTCUSNF" => $cdCentcusnf,
                        "P_VRRATENF"    => $vrRateNf,
                        "P_VRPERRAT"    => $vrPerRat,
                        "P_NRORG"       => $nrOrg); 
                        
        $query = $this->connection->prepare($sql);
        return $query->execute($params);    
    }
}