<?php

namespace Services\Logic;

class RecursoLogic {

	/* Verifica se um recurso está agendado ou não entre o período de datas passado.
    Função recebe o código do recurso, seu tipo, a data inicial e a data final como parâmetro, respectivamente.
    Retorna true para disponível, false para agendado. */
    public static function verificarDisponibilidade($codrecurso, $idtprecurso = 'F', $datainicial = null, $datafinal = null)
    {
    	$where = " WHERE CODRECURSO = '$codrecurso'
        			AND IDTPRECURSO = '$idtprecurso'";
    	if (!empty($datainicial) && !empty($datafinal)) {
    		$where .= " AND ( (('$datainicial' BETWEEN DTALOCARECUR AND DTFIMALOCARECUR)
	                   OR ('$datafinal' BETWEEN DTALOCARECUR AND DTFIMALOCARECUR) )
	                   OR ('$datainicial' < DTALOCARECUR AND '$datafinal' > DTFIMALOCARECUR) )";
    	}
        $sql = "SELECT COUNT(*) AS EXISTE FROM
				  (SELECT RC.NRSEQRECUCONT,
				   		  RC.NRORG,
				          RC.NRSEQCONTRATO,
				          CONT.NRCONTRATOFCT,
				          RC.DTALOCARECUR,
				          RC.DTFIMALOCARECUR,
				          RECURSO.CODRECURSO,
				          RECURSO.NMRECURSO,
				   		  RC.IDTPRECURSO
				    FROM FCT_RECURSOSCONTR RC
				   INNER JOIN FCT_CONTRATO CONT
				      ON RC.NRSEQCONTRATO = CONT.NRSEQCONTRATO
				     AND RC.NRORG         = CONT.NRORG
				    LEFT JOIN (SELECT NMBEMATIVO     AS NMRECURSO,
				                     CDPATRIBEMATIVO AS CODRECURSO,
				                     NRSEQRECUCONT
				                FROM BEMATIVO, FCT_RECURSOSCONTR
				               WHERE FCT_RECURSOSCONTR.CDBEMATIVO = BEMATIVO.CDBEMATIVO
				                 AND FCT_RECURSOSCONTR.CDEMPRESA  = BEMATIVO.CDEMPRESA
				                 AND FCT_RECURSOSCONTR.NRORG      = BEMATIVO.NRORG
				                 AND IDTPRECURSO                  = 'A'
				               UNION ALL
				              SELECT NMPRINCIPALPARC                    AS NMRECURSO,
				                     TO_CHAR(PARCNEGOCIO.NRPARCNEGOCIO) AS CODRECURSO,
				                     NRSEQRECUCONT
				                FROM PARCNEGOCIO, FCT_RECURSOSCONTR
				               WHERE FCT_RECURSOSCONTR.NRPARCNEGOCIO = PARCNEGOCIO.NRPARCNEGOCIO
				                 AND FCT_RECURSOSCONTR.NRORG         = PARCNEGOCIO.NRORG
				                 AND IDTPRECURSO                     = 'F'
				               UNION ALL
				              SELECT NMPRODUTO AS NMRECURSO,
				                     CDARVPROD AS CODRECURSO,
				                     NRSEQRECUCONT
				                FROM PRODUTO, FCT_RECURSOSCONTR
				               WHERE FCT_RECURSOSCONTR.CDPRODUTO = PRODUTO.CDPRODUTO
				                 AND FCT_RECURSOSCONTR.NRORG     = PRODUTO.NRORG
				                 AND IDTPRECURSO                 = 'P') RECURSO
				      ON RC.NRSEQRECUCONT = RECURSO.NRSEQRECUCONT) FCT_RECURSOSCONTR ".$where;
        
        $retorno = \Setforms2\Shared\Registry::getEntityManager()->getConnection()->fetchAll($sql);
        return ((int)$retorno[0]['EXISTE'] == 0);
    }
}